/*
 * The Script for "Scene description language by XML" 1.0
 * (SLAX-Script 1.0)
 * The module for loading files and handling scenes
 * (for MSIE 5.5/6.0 (or later), Firefox, Netscape 7(or later))
 * Copyright (C)2003-2007 Yutaka Furubayashi <info@yupotan.sppd.ne.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


//----------   Part 1 - Loading scenalios and constructing DOM  ------------

// ----- 1.1 Loading Scenario -----

var ns_esdl="http://purl.org/net/lena/ns/slax";
var ns_xlink="http://www.w3.org/1999/xlink"
var tt=top;
var ts=top.sub;

function xp(Num) {
 var xpForm="/*/*[@id='"+Num+"' and namespace-uri()='"+ns_esdl+"']";
 return xpForm;
}

// --- 1.2 Constructing object ---

function execute(xmlFile){
 scnNumber={"n0":0};
 xmlD = dc.Implementation.createDocument("", "", null);
 xmlD.addEventListener("load", setScenario, false);
 xmlD.load(xmlFile);
}

function setScenario(e) {
 showOrHide();
 var elms=xmlD.evaluate("//*[local-name()='i' and namespace-uri()='"+ns_esdl+"']",xmlD,null,6,null);
 var rootElm=xmlD.evaluate("//*[local-name()='scn' and namespace-uri()='"+ns_esdl+"']",xmlD,null,6,null).snapshotItem(0);
 var insElm=xmlD.createElementNS(ns_esdl,"s");
 var insJ=xmlD.createElementNS(ns_esdl,"j");
 insJ.setAttribute("href","");
 insElm.appendChild(insJ);
 insElm.setAttribute("id","");
 for (var i=0;i<elms.snapshotLength;i++){
  try {
  var ln=elms.snapshotItem(i).getAttribute("href");
  if (ln.charAt(0)!="#"){
   var Id="n999"+i;
   insElmClone=insElm.cloneNode(true);
   insElmClone.setAttribute("id",Id);
   insElmClone.firstChild.setAttribute("href",linkMode(ln).xpath);
   rootElm.appendChild(insElmClone);
   elms.snapshotItem(i).setAttribute("href","#n999"+i);
  }
  }
  catch (e){alert (ln=elms.snapshotItem(i))}
 }
 var elms=xmlD.evaluate("//*[((name()='p' or name()='bg' or name()='m' or name()='cg' or name()='se' or name()='mv' or name()='n' or name()='ni' or name()='bm-on' or name()='bm-off' or name()='addCG' or name()='rmCG' or name()='sh' or name()='c' or name()='jr' or name()='ret' or name()='stop' or name()='r' or name()='rp' or name()='rm' or name()='fon' or name()='fof' or name()='frv' or name()='div' or name()='over' or name()='thanks' or name='end') and namespace-uri()='"+ns_esdl+"') or (local-name()='j')]",xmlD,null,6,null);
 for (var i=0;i<elms.snapshotLength;i++){
  elms.snapshotItem(i).setAttribute("no",i);
 }
 enableContinue();
}


//----------   Part 2 - Reading scenalio(ESDL) documents  ------------


// ----- 2.1 Numbering of Child nodes -----

function Init(i){
 if (UA=="IE") return i;
 else return (i-1)/2;
}

function Num(i){
 if (UA=="IE") return i;
 else return 2*i+1;
}

// ----- 2.2 Streaming Scenalios -----

function dom_test() {
 senFlag=0;
 var x;
 while(senFlag==0) {
  var dn_0=divNode[0]+1;
  var dn_1=divNode[1]+1;
  var dn_2=divNode[2]+1;
  var dn_3=divNode[3]+1;
  switch(divLoop){
   case 0:
    x=xmlD.evaluate(xp(a)+"/*",xmlD,null,6,null).snapshotItem(dn_0-1);
   break;
   case 1:
    x=xmlD.evaluate(xp(a)+"/*["+dn_0+"]/*",xmlD,null,6,null).snapshotItem(dn_1-1);
   break;
   case 2:
    x=xmlD.evaluate(xp(a)+"/*["+dn_0+"]/*["+dn_1+"]/*",xmlD,null,6,null).snapshotItem(dn_2-1);
   break;
   case 3:
 x=xmlD.evaluate(xp(a)+"/*["+dn_0+"]/*["+dn_1+"]/*["+dn_2+"]/*",xmlD,null,6,null).snapshotItem(dn_3-1);

   break;
  }
  execCommand(x);
  if (!senFlag) {step();}
 }
 return false;
}

function step(){
  divNode[divLoop]++;
  var dn_0=divNode[0]+1;
  var dn_1=divNode[1]+1;
  var dn_2=divNode[2]+1;
  if (divLoop == 3) {
   if (divNode[3] == xmlD.evaluate(xp(a)+"/*["+dn_0+"]/*["+dn_1+"]/*["+dn_2+"]/*",xmlD,null,6,null).snapshotLength) {
    divLoop--;
    divNode[divLoop]++;
   }
  }
  if (divLoop == 2) {
   if (divNode[2] == xmlD.evaluate(xp(a)+"/*["+dn_0+"]/*["+dn_1+"]/*",xmlD,null,6,null).snapshotLength) {
    divLoop--;
    divNode[divLoop]++;
   }
  }
  if (divLoop == 1) {
   if (divNode[1] == xmlD.evaluate(xp(a)+"/*["+dn_0+"]/*",xmlD,null,6,null).snapshotLength) {
    divLoop--;
    divNode[divLoop]++;
   }
  }
  if (divNode[0] == xmlD.evaluate(xp(a)+"/*",xmlD,null,6,null).snapshotLength) {
   scn=xmlD.evaluate(xp(a)+"/following::*",xmlD,null,6,null).snapshotItem(0);
   if (scn) {a=scn.getAttribute("id");}
   divNode[0]=0;
   pathF=0;
  }
}


//----------   Part 3 - Executing Commands  ------------


function execCommand(E) {
 var com1=E.tagName;
 if (!skipFlag && pageNumber!= tt.endingPage && pageNumber!=tt.cornerPage && pageNumber!=tt.afterEndingPage) {
  var pf=parseInt(E.getAttribute("no"),10);
  if (!tt.pathFlag[pageNumber][pf]) {
   tt.pathFlag[pageNumber][pf]=1;
   if (com1=="p" || com1=="c" || com1=="ni") tt.completedFlag[pageNumber]++;
  }
 }
 if (skipFlag && tt.configSwitch[4] && !tt.pathFlag[pageNumber][parseInt(E.getAttribute("no"),10)]){
  skipFlag=0;
  continueScinario();
  autoPlayControl(1,0);
 }

 if (!condFlag(E.getAttribute("c"))) return;
 switch (com1) {

// ----- 3.1 Making choice -----

 case "c":
  if (skipFlag) {
   skipFlag=0;
   continueScinario();
  }
  choiceable=true;
  showOrHide();
  autoPlayControl(0,0);
  while(choiceForm.hasChildNodes()) {
   choiceForm.removeChild(choiceForm.childNodes[0]);
  }
  var ii,ib,choiceNode,choicePage,choiceTo,al;
  ib=0;
  var choiceUnits = E.getElementsByTagName("i");
  ii=choiceUnits.length;
  var ddList=dc.createElementNS(nsx,"dd");
  ddList.appendChild(dc.createElementNS(nsx,"a"));
  var dtList=dc.createElementNS(nsx,"dt");
  for (var ia=0,dtClone,ddClone;ia<ii;ia++) {
   if (condFlag(choiceUnits[ia].getAttribute("c"))) {
    choiceLink=linkMode(choiceUnits[ia].getAttribute("href"));
    choiceTo=choiceLink.t;
    choiceNode=choiceLink.nd;
    if (choiceLink.page) {
     choicePage=chiceLink.page;
    }
    else {
     choicePage="'no'";
    }
    
    dtClone=dtList.cloneNode(true);
    ddClone=ddList.cloneNode(true);
    dtClone.appendChild(dc.createTextNode(ib+1));
    var x=ddClone.firstChild;
    serifRenderingSub(x,choiceUnits[ia]);
    choiceFormat[ib] = '"'+choiceTo+'",'+choiceNode+","+choicePage;
    x.setAttribute("href","javascript:choiceJump("+choiceFormat[ib]+");");
    var _num=parseInt(xmlD.evaluate(xp(choiceTo)+"/*",xmlD,null,6,null).snapshotItem(choiceNode-1).getAttribute("no"),10);
    x.style.color=(pageNumber!= tt.endingPage && pageNumber!=tt.cornerPage && pageNumber!=tt.afterEndingPage && tt.configSwitch[5] && tt.pathFlag[pageNumber][_num]) ? tt.linkVisitedColor : tt.linkColor;
    choiceForm.appendChild(dtClone);
    choiceForm.appendChild(ddClone);
    ib++;
   }
  }
  if (tt.choiceAlign) choiceForm.style.top=(245-ib*15)+"px";
  choiceForm.style.visibility="visible";
  senFlag=1;
 break;

// ----- 3.2 Stop streaming during "skip" command -----

 case "stop":
  if (!skipFlag){break;}
  skipFlag=0;
  continueScinario();
  autoPlayControl(1,0);
  break;

// ----- 3.3 Change streaming -----

 case "j":
   divLoop=0;
   pathF=0;
   var lk=E.getAttribute("href");
   a=linkMode(lk).t;
   divNode[0]=linkMode(lk).nd-2;
   if (linkMode(lk).page) {
    autoPlayControl(0,0);
    clickable=false;
    moveFlag=true;
    showOrHide();
    senFlag=1;
    divNode[0]++;
    pageNumber=parseInt(linkMode(lk).page,10);
    execute(linkMode(lk).page);
   }
   else {
    scn=xmlD.evaluate(xp(a),xmlD,null,6,null).snapshotItem(0);
   }
 break;

// ----- 3.3.1 Subroutines -----

 case "jr":
  if (routineFlag) break;
  routineFlag=1;
  pageNumber_old=pageNumber;
  for (var i=0;i<divNode.length;i++){divNode_old[i]=divNode[i];}
  divLoop_old=divLoop;
  a_old=a;
  divLoop=0;
  pathF=0;
  var lk=E.getAttribute("href");
  a=linkMode(lk).t;
  divNode[0]=linkMode(lk).nd-2;
  if (linkMode(lk).page) {
   autoPlayControl(0,0);
   clickable=false;
   moveFlag=true;
   showOrHide();
   senFlag=1;
   divNode[0]++;
   pageNumber=parseInt(linkMode(lk).page,10);
   execute(linkMode(lk).page);
  }
  else {
   scn=xmlD.evaluate(xp(a),xmlD,null,6,null).snapshotItem(0);
  }
 break;

 case "ret":
  if (!routineFlag) break;
  routineFlag=0;
  for (var i=0;i<divNode.length;i++){divNode[i]=divNode_old[i];}
  divLoop=divLoop_old;
  pathF=0;
  a=a_old;
  if (pageNumber != pageNumber_old) {
   autoPlayControl(0,0);
   clickable=false;
   moveFlag=true;
   showOrHide();
   senFlag=1;
   divNode[0]++;
   pageNumber=pageNumber_old;
   execute(pageNumber+".xml");
  }
  else {
   scn=xmlD.evaluate(xp(a),xmlD,null,6,null).snapshotItem(0);
  }
 break;

// ----- 3.4 Flags control (boolean) -----

 case "fon":
  flag[parseInt(E.getAttribute("n"),10)]=1;
 break;

 case "fof":
  flag[parseInt(E.getAttribute("n"),10)]=0;
 break;

 case "frv":
  var i=parseInt(E.getAttribute("n"),10);
  if (flag[i]) {flag[i]=0} else {flag[i]=1;}
 break;

// ----- 3.5 Flags control (non negative integer) -----

 case "rp":
  var i=parseInt(E.getAttribute("n"),10);
  if (reg[i] < 131072) {reg[i]++;}
 break;

 case "rm":
  var i=parseInt(E.getAttribute("n"),10);
  if (reg[i] > -131071) {reg[i]--;}
 break;

 case "r":
  var i=parseInt(E.getAttribute("n"),10);
  reg[i]=Math.round(calcVal(E.getAttribute("v")));
  if (reg[i]>131072) {reg[i]=131072;}
  if (reg[i]<-131071) {reg[i]=-131071;}
 break;


// ----- 3.6 Background -----

 case "bg":
  var comm2=E.getAttribute("src");
  if (comm2 == "off") {comm2=0;}
  if (!comm2.toString().match(/\./)) comm2+=".jpg";
  if (UA == "IE") { // Blending Images for MSIE
   background.filters.blendTrans.Apply();
   background.filters.blendTrans.duration=0.8;
  }
  background.setAttribute("src","bg/"+comm2);
  if (UA == "IE") {
   background.filters.blendTrans.Play();
  }
  if (!skipFlag && parseInt(pageNumber,10) != 20) {
    for (var i=0;i<tt.favoriteCG.length;i++) {
     if (comm2 == tt.favoriteCG[i]) {tt.cgFlag[i]=1; break;}
    }
   }
   backNumber=comm2;
 break;

// ----- 3.7 Setting Charactor (for one person) -----

 case "cg":
  var comm3;
  switch (E.getAttribute("align")){
   case "left": comm3=0; break;
   case "center": comm3=1; break;
   default: comm3=2; break;
  }
  var comm2=E.getAttribute("src");
  if (comm2 == "off") {comm2="0";}
  if (!comm2.match(/\./)) comm2+=".png";
  if (UA == "IE") { // Blending Images for MSIE
   charactor[comm3].filters.blendTrans.Apply();
   charactor[comm3].filters.blendTrans.duration=0.8;
  }
  charactor[comm3].setAttribute('src', 'chr/'+comm2);
  if (UA == "IE") {
   charactor[comm3].filters.blendTrans.Play();
  }
  personNumber[comm3]=comm2;
 break;

// ----- 3.8 Background music (MIDI) -----

 case "m":
  var comm2=E.getAttribute("src");
  if (!comm2.match(/\./) && comm2 !="off") comm2=parseInt(comm2,10).toString()+".mid";
  if (E.getAttribute("l") == "false") {loopBGM=false;} else {loopBGM=true;}
  if (comm2 != midiNumber) {
   if (!skipFlag) tt.playBGM(comm2,comm2 != "off" && tt.configSwitch[0] == 0 && skipFlag == 0,loopBGM);
   midiNumber = comm2;
  }
 break;

 case "se":
  var comm2=E.getAttribute("src");
  comm2=(comm2=="off") ? "0" : comm2;
  if (comm2 != seNumber) {
   if (!skipFlag) tt.playSE(comm2,comm2 != "off" && tt.configSwitch[2] == 0 && skipFlag == 0,loopBGM);
   seNumber=comm2;
  }
 break;

// ----- 3.8.1 Background Movie ----

 case "mv":
  mvNumber=parseInt(E.getAttribute("src"),10);
  if (skipFlag) {break;}
  mvFlag=true;
  clickable=false;
   dc.getElementById("mv").style.visibility="visible";
   movieForm.style.visibility="visible";
   movieForm.style.zIndex="5";
   try {
    movieForm.GotoFrame(mvNumber);
   }
   catch(e) {}
   senFlag=1;

 break;

// ----- 3.9 Serif and/or messages -----

 case "p":
  if (skipFlag && E.getAttribute("skip")!="true") {break;}
  var ssss=dc.getElementsByTagName("dt")[0];
  var p_tmp=E.getAttribute("p");
  if (p_tmp == undefined) {
   spek="no";
   ssss.style.visibility="hidden";
  }
  else {
   spek=tt.renderTitle(p_tmp,reg,nm);
   if (serifbox.style.visibility!="hidden") {
    ssss.style.visibility="visible";
   }
  }
  seri=E;
  serifRendering();
  if (E.getAttribute("skip")!="true")senFlag=1;
 break;

 case "bm-on":
  var ssss=dc.getElementsByTagName("dt")[0];
  var ba,bb,bc,bd;
  if (E.getAttribute("t")) {sTop=parseInt(E.getAttribute("t"),10)} else {sTop=200}
  if (E.getAttribute("l")) {sLeft=parseInt(E.getAttribute("l"),10)} else {sLeft=40}
  if (E.getAttribute("w")) {sWidth=parseInt(E.getAttribute("w"),10)} else {sWidth=560}
  if (E.getAttribute("cl")) {sColor=E.getAttribute("cl")} else {sColor="white"}
  with (ssss.style){
   top=(sTop-30)+"px";
   left=(sLeft-10)+"px";
   color=sColor;
   backgroundImage="none";
   backgroundColor="transparent";
   borderWidth="0px";
   textAlign="left";
  }
  with (serifbox.style){
   top=sTop+"px";
   left=sLeft+"px";
   width=sWidth+"px";
   color=sColor;
   backgroundImage="none";
   backgroundColor="transparent";
   borderWidth="0px";
  }
 break;

 case "bm-off":
  var ssss=dc.getElementsByTagName("dt")[0];
  sColor="off";
  with (ssss.style){
   top="";
   left="";
   color="";
   backgroundImage="";
   backgroundColor="";
   borderWidth="3px";
   textAlign="";
  }
  with (serifbox.style){
   top="";
   left="";
   width="";
   backgroundImage="";
   backgroundColor="";
   borderWidth="3px";
  }
 break; 

// ----- 3.10 Conditional control -----

 case "div":
  divLoop++;
  divNode[divLoop]=-1;
 break;

// ----- 3.11 Endings and Game-over -----

 case "over":
  var col;
  if (E.getAttribute("cl")) {col=E.getAttribute("cl")} else {col="white"}
  ts.saveCookie("H");
  addComment("Game Over...",col);
 break;

 case "thanks":
  var col;
  if (E.getAttribute("cl")) {col=E.getAttribute("cl")} else {col="white"}
  if (E.getAttribute("clear")!="false") {tt.endingFlag[0]=0;}
  ts.saveCookie("H");
  addComment("Thank you for playing with us !! See you again !!",col);
 break;

 case "end":
  keyFlag=1;
  tt.configSwitch[3]=0;
  clickable=false;
  var endingNumber=parseInt(E.getAttribute("n"),10);
  showOrHide();
  if (E.getAttribute("how")=="bad"){
   ts.endingNumber="b"+endingNumber;
   endingNumber+=tt.goodEndingTheme.length;}
  else {
   ts.endingNumber="g"+endingNumber;
  }
  dc.getElementById('persons').style.display="none";
  dc.getElementById('images').style.display="none";
  background.style.display="none";
  viewable=false;
  senFlag=1;
  saveGameFlag(endingNumber);
  ts.saveCookie();
  ending(endingNumber);
 break;

// ----- 3.12 Additional Images -----

 case "addCG":
  var newCG=parseInt(E.getAttribute("n"));
  if (UA == "IE") { // Blending Images for MSIE
   atCG[newCG].filters.blendTrans.Apply();
   atCG[newCG].filters.blendTrans.duration=0.8;
  }
  with (attachedCG[newCG]) {
   file=E.getAttribute("src");
   top=parseInt(E.getAttribute("t"),10);
   left=parseInt(E.getAttribute("l"),10);
   width=parseInt(E.getAttribute("w"),10);
   height=parseInt(E.getAttribute("h"),10);
   z=(E.getAttribute("z") != undefined) ? parseInt(E.getAttribute("z"),10) : 3;
  }
  atCG[newCG].setAttribute("src","attach/"+E.getAttribute("src"));
  with (atCG[newCG].style) {
   position="absolute";
   top=attachedCG[newCG].top+"px";
   left=attachedCG[newCG].left+"px";
   width=attachedCG[newCG].width+"px";
   height=attachedCG[newCG].height+"px";
   zIndex=attachedCG[newCG].z;
  }
  if (UA == "IE") {
   atCG[newCG].filters.blendTrans.Play();
  }
 break;

 case "rmCG":
  var newCG=parseInt(E.getAttribute("n"));
  with (attachedCG[newCG]) {
   file="0.png";
   top=0;
   left=0;
   width=0;
   height=0;
   z=0;
  }
  atCG[newCG].setAttribute("src","chr/0.png");
  if (UA == "IE") {
   atCG[newCG].filters.blendTrans.Play();
  }
 break;

// ----- 3.13 Shaking Window -----

 case "sh":
  var tm;
  if (UA=="IE"){tm=0;} else {tm=300;}
  var qu=E.getAttribute("str");
  if (!tt.configSwitch[3]) playID_q=setTimeout("shakeWindow('"+qu+"');",tm);
 break;

// ----- 3.14 Charactor constants -----

 case "n":
  nm[parseInt(E.getAttribute("n"),10)]=E.getAttribute("v");
 break;

 case "ni":
  var n_tmp,msg,msg2="";
  msg= (E.getElementsByTagName("l").length) ? (E.getElementsByTagName("l")) : [E];
  for (var i=0;i<msg.length;i++) {
   msg2+=(toMessage(msg[i])+"\n");
  }
  var n_tmp=prompt(msg2,E.getAttribute("def"));
  if (!n_tmp) n_tmp=E.getAttribute("def");
  nm[parseInt(E.getAttribute("n"),10)]=n_tmp;
 break;


// ----- 3.15 Find fields -----
 case "find":
  findFlag=1;
  autoPlayControl(0,0);
  clickable=false;
  if (skipFlag) {
   skipFlag=0;
   continueScinario();
  }
  cgItems=E.getAttribute("n").split(" ");
  textSwitch=(!E.getAttribute("text") || E.getAttribute("text")!="on") ? false : true;
  comSwitch=(!E.getAttribute("com") || E.getAttribute("com")!="on") ? false : true;
  showOrHide();
//  var text=tt.renderTitle(E.firstChild.nodeValue);
  try {
   if (E.getAttribute("mouse")) background.style.cursor=E.getAttribute("mouse");
  }
  catch(_e){}
  if (!comSwitch) menuSection.removeEventListener("mouseover", showMenu, false);
  dc.removeEventListener("click", mainStream, false);
  dc.removeEventListener("dblclick", mainStream, false);
  dc.addEventListener("click",findItem_pre, true);
  senFlag=1;
 break;

 }
}


// ------- End of file -----
