<!--
 * xhtml11-htmlpref-core.mod ; DTD subset for XHTML 1.1 with html-prefix
 * Copyright (C)2003-2007 Yutaka Furubayashi <info@yupotan.sppd.ne.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
-->

<!-- Part 1 - Entity set -->


<!-- Tokens defined by other standards -->

<!ENTITY % Content-Type "CDATA">
<!-- MIME content type, RFC1521 -->

<!ENTITY % HTTP-Method "(get | post)">
<!-- as per HTTP/1.1 RFC2068  -->

<!ENTITY % URI "CDATA">
<!-- Universal Resource Identifier, RFC1630 -->

<!ENTITY % scripts "CDATA">
<!-- Script used as ECMAScript, etc. -->

<!-- Element tokens -->

<!ENTITY % special "html:a | html:img | html:object | q" >

<!-- Logical character styles -->
<!ENTITY % logical.styles "cite | dfn | em | span | strong | html:em | html:span | html:strong" >

<!-- Model groups -->

<!-- Block-like elements eg. paragraphs and lists -->
<!ENTITY % block "blockquote | dl | html:form | div |
                   ol | p | html:pre | html:table | ul | html:ul" >

<!-- Form fields - input elements that should appear only within forms -->
<!ENTITY % form.fields "html:input | html:label | html:select | html:textarea" >

<!-- Character level elements and text strings -->
<!ENTITY % text "#PCDATA | %logical.styles; | %special;
                         | %form.fields;" >

<!-- Elements that may appear in a section  -->

<!ENTITY % head.special "" >
<!ENTITY % head.content "link | html:meta | html:script %head.special;" >
<!ENTITY % section.content "%text; | %block;" >
<!ENTITY % table.content "%text; | blockquote | dl | html:form |
                   ol | p | html:pre | ul" >

<!ENTITY % address.content
   "(#PCDATA | %logical.styles; | %form.fields; | html:a | q)*">
<!ENTITY % pre.content
   "(#PCDATA | %logical.styles; | %form.fields; | html:a | q)*">
<!ENTITY % a.content
   "(#PCDATA | %logical.styles; | %form.fields; | html:img | html:object | q)*">
<!ENTITY % form.content "blockquote | div | dl |
                   ol | p | html:pre | ul" >

<!-- Generic attributes -->

<!ENTITY % href "">

<!ENTITY % core-without-href
   "class      CDATA      #IMPLIED 
    id         ID         #IMPLIED
    title      CDATA      #IMPLIED " >

<!ENTITY % core
   "class      CDATA      #IMPLIED 
    id         ID         #IMPLIED
    %href;
    title      CDATA      #IMPLIED " >

<!ENTITY % events
   "onclick      %scripts;  #IMPLIED 
    onmouseover  %scripts;  #IMPLIED
    onkeypress   %scripts;  #IMPLIED
    onmouseout   %scripts;  #IMPLIED " >


<!-- Internationalization attributes -->

<!ENTITY % i18n
"    xml:lang       CDATA       #IMPLIED" >

<!-- Presentation styles -->

<!ENTITY % InputType "(checkbox | hidden | password | 
                       radio | reset | submit | text)" >


                <!-- Part 2 - Document structure -->

<!-- Further normative requirements on the elements defined in this part
     of the DTD are provided in Part 3.-->
<!--      ELEMENTS    MIN  CONTENT  (EXCEPTIONS) -->
<!ELEMENT html         (head, (body|html:body)) >
<!ELEMENT head       ((%head.content;)*, (html:title),(%head.content;)*) >
<!ELEMENT html:title     (#PCDATA)  >
<!ELEMENT html:script    (#PCDATA)  >
<!ELEMENT link        EMPTY >
<!ELEMENT html:meta      EMPTY >

<!ENTITY % div6.content  "(%block;)*" >
<!ENTITY % div5.content  "(%block;)*, (h6,%div6.content;)* " >
<!ELEMENT h6          (%text;)* >
<!ENTITY % div4.content  "(%block;)*, (h5,%div5.content;)* " >
<!ELEMENT h5           (%text;)* >
<!ENTITY % div3.content  "(%block;)*, (h4,%div4.content;)* " >
<!ELEMENT h4           (%text;)* >
<!ENTITY % div2.content  "(%block;)*, (h3,%div3.content;)* " >
<!ELEMENT h3           (%text;)* >
<!ENTITY % div1.content  "(%block;)*, (h2,%div2.content;)* " >
<!ELEMENT h2           (%text;)* >
<!ELEMENT h1           (%text;)* >
<!ELEMENT html:body        (h1, (%div1.content;)) >
<!ELEMENT body        (h1, (%div1.content;)) >

<!ELEMENT div          ((%block;|address)*) >
<!ELEMENT address  %address.content; >
<!ELEMENT p             (%text;)* >
<!ELEMENT ul   (li|html:li)* >
<!ELEMENT html:ul   (li|html:li)* >
<!ELEMENT ol   (li|html:li)* >
<!ELEMENT li     (%section.content;)* >
<!ELEMENT html:li     (%section.content;)* >
<!ELEMENT dl    (dt,dd*)+ >
<!ELEMENT dt    (%text;)* >
<!ELEMENT dd   (%section.content;)* >
<!ELEMENT html:pre  %pre.content; >
<!ELEMENT blockquote  (%block;)+ >
<!ELEMENT q           (%text;)* >

<!ELEMENT html:form  (%form.content;)+ >
<!ELEMENT html:input        EMPTY >
<!ELEMENT html:label        (%text;)* >
<!ELEMENT html:select      (html:option)+ >
<!ELEMENT html:option      (#PCDATA) >
<!ELEMENT html:textarea    (#PCDATA) >

<!ELEMENT html:table       ((html:caption)?, (html:tr)+) >
<!ELEMENT html:caption     (%text;)* >
<!ELEMENT html:tr          (html:td|html:th)+ >
<!ELEMENT html:th          (%table.content;)* >
<!ELEMENT html:td          (%table.content;)* >

<!ELEMENT cite  (%text;)* >
<!ELEMENT dfn  (%text;)* >
<!ELEMENT em  (%text;)* >
<!ELEMENT html:em  (%text;)* >
<!ELEMENT strong  (%text;)* >
<!ELEMENT span  (%text;)* >
<!ELEMENT html:span  (%text;)* >
<!ELEMENT html:strong  (%text;)* >
<!ELEMENT html:a           %a.content; >
<!ELEMENT html:img        EMPTY >
<!ELEMENT html:object      (%section.content; | html:param)* >
<!ELEMENT html:param       EMPTY >

<!-- Part 3 - Attribute definition lists -->

<!--      ELEMENTS 
    NAME       VALUE       DEFAULT --> 

<!ATTLIST html:a
    %core-without-href;
    %i18n;
    %events;
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    accesskey  CDATA      #IMPLIED 
    charset    CDATA      #IMPLIED 
    href       %URI;      #IMPLIED 
    hreflang   CDATA       #IMPLIED 
    rel        CDATA      #IMPLIED 
    rev        CDATA      #IMPLIED
    tabindex   CDATA      #IMPLIED 
    type       CDATA      #IMPLIED >

<!ATTLIST address
    %events;
    %core; 
    %i18n;  >

<!ATTLIST blockquote
    %events;
    %core-without-href; 
    %i18n;
    CITE       %URI;      #IMPLIED >

<!ATTLIST body
    %core-without-href; 
    %i18n; >

<!ATTLIST html:body
    xmlns:html  CDATA     #FIXED 'http://www.w3.org/1999/xhtml'
    %core-without-href; 
    %i18n;
    %events;
    onload     %scripts;  #IMPLIED >

<!ATTLIST html:caption
    %events;
    %core;
    %i18n;
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml' >

<!ATTLIST dd
    %events;
    %core;  
    %i18n;  >

<!ATTLIST div
    %events;
    %core; 
    %i18n; >

<!ATTLIST dl
    %events;
    %core; 
    %i18n;  >

<!ATTLIST dt
    %events;
    %core; 
    %i18n;  >


<!ATTLIST html:form
    %events;
    %core-without-href; 
    %i18n;  
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    action     %URI;     #REQUIRED
    enctype    %Content-Type; "application/x-www-form-urlencoded"
    method     %HTTP-Method;  "get" >

<!ATTLIST head
    %i18n;  
    profile    %URI;      #IMPLIED >

<!ATTLIST html 
    xmlns    CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %i18n;  >

<!ATTLIST h1
    %events;
    %core;
    %i18n;  >

<!ATTLIST h2
    %events;
    %core;
    %i18n;  >

<!ATTLIST h3
    %events;
    %core;
    %i18n;  >

<!ATTLIST h4
    %events;
    %core;
    %i18n;  >

<!ATTLIST h5
    %events;
    %core;
    %i18n;  >

<!ATTLIST h6
    %events;
    %core;
    %i18n;  >

<!ATTLIST html:img
    %events;
    %core-without-href; 
    %i18n;  
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    alt        CDATA     #REQUIRED 
    longdesc   %URI;      #IMPLIED 
    src        %URI;     #REQUIRED >

<!ATTLIST html:input
    %events;
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %core-without-href; 
    %i18n;  
    accesskey  CDATA      #IMPLIED
    checked    (checked)  #IMPLIED 
    maxlength  CDATA     #IMPLIED 
    name       CDATA      #IMPLIED 
    size       CDATA      #IMPLIED 
    tabindex   CDATA       #IMPLIED
    type       %InputType;    "text"
    value      CDATA      #IMPLIED >

<!ATTLIST html:label
    %events;
    %core;
    %i18n; 
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    accesskey  CDATA      #IMPLIED 
    for        IDREF      #IMPLIED >


<!ATTLIST li
    %events;
    %core; 
    %i18n; >

<!ATTLIST html:li
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %events;
    %core; 
    %i18n; >

<!ATTLIST link
    %core-without-href;  
    %i18n;  
    charset    CDATA      #IMPLIED 
    href       %URI;      #IMPLIED 
    hreflang   CDATA       #IMPLIED 
    media      CDATA      #IMPLIED 
    rel        CDATA      #IMPLIED 
    rev        CDATA      #IMPLIED
    type       CDATA      #IMPLIED >

<!ATTLIST html:meta     
    %i18n; 
    xmlns:html CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    content    CDATA     #REQUIRED 
    http-equiv CDATA       #IMPLIED 
    name       CDATA       #IMPLIED 
    scheme     CDATA      #IMPLIED >

<!ATTLIST html:object   
    %core-without-href; 
    %i18n; 
    %events;
    xmlns:html CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    data       %URI;      #IMPLIED
    type       CDATA      #IMPLIED 
    name       CDATA      #IMPLIED 
>

<!ATTLIST ol
     %events;
     %core; 
     %i18n; >

<!ATTLIST html:option
    %events;
    %core-without-href;   
    %i18n;  
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    selected   (selected) #IMPLIED 
    value      CDATA      #IMPLIED
>

<!ATTLIST p
    %events;
    %core;  
    %i18n;   >

<!ATTLIST html:param
    xmlns:html CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    id         ID         #IMPLIED 
    name       CDATA      #REQUIRED 
    type       CDATA      #IMPLIED 
    value      CDATA      #IMPLIED 
    valuetype  (data|ref|object)
                              "data" >

<!ATTLIST html:pre
    %events;
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %core; 
    %i18n;  >

<!ATTLIST q
    %events;
    %core-without-href; 
    %i18n;  
    cite       %URI;      #IMPLIED >

<!ATTLIST html:script
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    src        %URI;     #IMPLIED 
    type       CDATA     #REQUIRED
    charset    CDATA     #IMPLIED 
    tabindex   CDATA     #IMPLIED >

<!ATTLIST html:select
    %core-without-href; 
    %i18n;   
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    multiple   (multiple) #IMPLIED 
    name       CDATA     #REQUIRED
    size       CDATA     #IMPLIED 
    tabindex   CDATA     #IMPLIED >

<!ATTLIST html:table
    %events;
    %core;
    %i18n; 
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml'
    summary    CDATA     #REQUIRED >

<!ATTLIST html:td
    %events;
    %core;
    %i18n; 
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml'
    abbr         CDATA          #IMPLIED
    axis         CDATA          #IMPLIED
    headers      IDREFS         #IMPLIED
    scope      (col|row)       #IMPLIED 
    rowspan      CDATA        '1'
    colspan      CDATA        '1' >

<!ATTLIST html:th
    %events;
    %core;
    %i18n; 
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml'
    abbr         CDATA          #IMPLIED
    axis         CDATA          #IMPLIED
    headers      IDREFS         #IMPLIED
    scope      (col|row)       #IMPLIED 
    rowspan      CDATA        '1'
    colspan      CDATA        '1' >

<!ATTLIST html:tr
    %events;
    %core;
    %i18n; 
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml' >

<!ATTLIST html:textarea
    %events;
    %core-without-href; 
    %i18n;  
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml'
    accesskey  CDATA      #IMPLIED
    cols       CDATA    #REQUIRED 
    name       CDATA     #REQUIRED
    rows       CDATA    #REQUIRED 
    tabindex   CDATA     #IMPLIED  >

<!ATTLIST html:title
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml'
    %i18n;  >

<!ATTLIST ul
    %events;
    %core;  
    %i18n;  >

<!ATTLIST html:ul
    xmlns:html  CDATA    #FIXED 'http://www.w3.org/1999/xhtml'
    %events;
    %core;  
    %i18n;  >

<!-- Attribute group definition lists -->

<!ATTLIST cite
    %core; 
    %i18n;  >

<!ATTLIST em
    %core; 
    %i18n;  >

<!ATTLIST html:em
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %core; 
    %i18n;  >

<!ATTLIST dfn
    %core; 
    %i18n;  >

<!ATTLIST strong
    %core; 
    %i18n;  >

<!ATTLIST html:strong
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %core; 
    %i18n;  >

<!ATTLIST span
    %core; 
    %events;
    %i18n;  >

<!ATTLIST html:span
    xmlns:html  CDATA      #FIXED 'http://www.w3.org/1999/xhtml'
    %core; 
    %events;
    %i18n;  >

<!-- End of file -->
